// Copyright (c) 2019, the Dart project authors. Please see the AUTHORS file
// for details. All rights reserved. Use of this source code is governed by a
// BSD-style license that can be found in the LICENSE file.

import 'package:analyzer/src/error/codes.dart';
import 'package:test_reflective_loader/test_reflective_loader.dart';

import '../dart/resolution/driver_resolution.dart';

main() {
  defineReflectiveSuite(() {
    defineReflectiveTests(CaseBlockNotTerminatedTest);
  });
}

@reflectiveTest
class CaseBlockNotTerminatedTest extends DriverResolutionTest {
  test_caseBlockNotTerminated() async {
    await assertErrorsInCode('''
f(int p) {
  switch (p) {
    case 0:
      f(p);
    case 1:
      break;
  }
}''', [
      error(StaticWarningCode.CASE_BLOCK_NOT_TERMINATED, 30, 4),
    ]);
  }
}
